let timescale = [
  60, "minutes";
  3600, "hours";
  3600*24, "days";
  3600*24*7, "weeks";
  3600*24*30, "months";
  3600*24*365, "years"
]
  
let tell what now =
  let solong t1 t2 = 
    let delta = int_of_float (t2 -. t1) in
    let rec humandelay name div x = function
    [] -> Printf.sprintf "%d %s" (x/div) name
      | t::q -> if fst t > x then Printf.sprintf "%d %s" (x/div) name
	else humandelay (snd t) (fst t) x q
    in humandelay "seconds" 1 delta timescale
  in "age="^(solong (snd what) now)^", time stamp="^(string_of_float (snd what))^", md5="^(fst what)

let now = Unix.time ()

let compiled = Printf.sprintf "compiled with Ocaml %s (%dbit, cache_size=%dKB, %dbit ints, %dbit array index)" 
  Sys.ocaml_version Sys.word_size (Kernel.bytes_in_cache lsr 10) Kernel.max_int_bit Kernel.max_array_bit

let components = ["kernel: "^(tell (Signature.sig_fun "kernel") now);
		  ("shell: "^(tell (Signature.sig_fun "main") now));
		  ("GUI: "^(tell (Signature.sig_fun "interactive") now));
		  ("PRNG: "^(tell (Signature.sig_fun "random2") now));
		  ("dynloader: "^(tell (Signature.sig_fun "load") now));
		  ("keymap: "^(tell (Signature.sig_fun "keymap") now));
		  ("debug: "^(tell (Signature.sig_fun "debug") now))
		 ]
let rubriks = [
  "About",
  "
ACML is a cellular automata simulator that focuses on easy definition and exploration of arbitrary rules and initial configurations.\n
<a href=\"http://theyssier.perso.math.cnrs.fr/acml/\">Online help</a>\n
<i>About this version:\n\n"^compiled^"\n\n"^(String.concat "\n\n" components^"</i>");
  "General help", 
  "
<i>Below is the technical detailed description of the main aspects of ACml. You should go to the <a href=\"http://theyssier.perso.math.cnrs.fr/acml/\">webpage of ACml</a> for a more gentle introduction.</i>\n
<b>Main loop</b>
<i>1. if play=on then apply CA rule to current configuration </i>
<i>2. if play=on then apply measurements to current configuration </i>
<i>3. if play=on then apply plugins tagged \"after each step\" </i>
<i>4. if play=on then do a snapshot if shooting option and shot interval say so </i>
<i>5. stop simulation (play=off) if stoptime is reached </i>
<i>6. react to all queued events (scenario) </i>
<i>7. if interactive then read interactions (blocking if play=off) and react </i>
\n<b>Make All</b>
<i>1. Current object = (CA_0, conf_0, other_0) </i>
<i>2. Apply activated plugins of type \"before new object\"</i>
<i>3. Apply transformation function of the current family </i>
<i>4. Apply activated plugins of type \"after new object\"</i>
<i>5. Result = (CA_1, conf_1, other_1) </i>
<i>6. New current object = (CA_1, conf_1, other_1) </i>
\n<b>Make Conf</b>
<i>1. Current object = (CA_0, conf_0, other_0) </i>
<i>2. Apply activated plugins of type \"before new object\"</i>
<i>3. Apply transformation function of the current family </i>
<i>4. Apply activated plugins of type \"after new object\"</i>
<i>5. Result = (CA_1, conf_1, other_1) </i>
<i>6. New current object = (CA_0, conf_1, other_1) </i>
\n<b>Make Other</b>
<i>1. Current object = (CA_0, conf_0, other_0) </i>
<i>2. Apply activated plugins of type \"before new object\"</i>
<i>3. Apply transformation function of the current family </i>
<i>4. Apply activated plugins of type \"after new object\"</i>
<i>5. Result = (CA_1, conf_1, other_1) </i>
<i>6. New current object = (CA_0, conf_0, other_1) </i>
"
  ;
  "Mouse usage", 
  "<i>This applies to the view window only.</i>\n
<b>mouse wheel: </b> zoom (up=in / down=out)\n
<b>mouse buttons: </b>each mouse button can be affected to a specific action in the user interface.
For each button a simple <i>click</i> will execute the corresponding action on a single cell, and a <i>press-move-release</i> execute the action on a region.\n
<b>region selection: </b>by default a region is rectangular (corners= press point and release point). If you hold 'control' the region is limited to a vertical or horizontal segment starting from the press point (vertical or horizontal depending on the shape of the rectangle).  If you hold 'shift' the region is a diagonal (the maximal segment of slope 45° starting from the press point and contained in the rectangle).\n
<b>changing action via keyboard while selecting region: </b> if you hold a shortcut key pressed while releasing the mouse button, the action executed is the one linked to the key (see keyboard shorcuts), and this can of course be combined with shift/control to change the shape of the region.
You can cancel a selection by pressing any inactive key while releasing mouse button.\n
<b>mouse wheel: </b> zoom (up=in / down=out)
"
  ;
]
