let name = "Additive Cellular Automata"
let description = "The new value of a cell is the sum (modulo number of states) of its neighboring cells plus a constant"

open Acml

let maker a =
  (
    let (d,n,r,neig) = std_params ~dimension:1 ~states:2 ~radius:1 ~neighborhood:"Moore" a in
    set_name a name;
    add_description a "Transition rule" description;
    let affine = param a "affine" 0 (n-1) 0  in
    set_rule a (fun x -> (Array.fold_left (+) affine x) mod n);
    let x,y = get_universe_size a in
    add_init_conf a "Single non-zero" (General (fun a b -> if a = x/2 && 
							 (d=1 || b = y/2) then 1 + (conf_random (n-1)) else 0));
    doc_param a "affine" "Constant to be added at each step";
  )

let _ = valid maker
