let family_name = "Minority vote"
let description = "The new state is always one of those having the minimal (non-zero) number of occurrences in the neighborhood.\n 
In case of equality, the state is unchanged or an arbitrary choice is made depending on parameters."

open Acml

let maker a =  
  let  (d,n,r,_) = std_params ~states:2 ~radius:1 a in
    set_name a family_name;
    add_description a "Rule" description;
    set_cardinality a n;
    let keep = bool_param a "Stay unchanged in case of equality" true in
    let captive = bool_param a "Captive" true in
      set_multiset_rule a (fun c multiset ->
 			     let (_,m,l) = Array.fold_left (fun acc x -> let (p,m,l) = acc in 
							      if x<m && (x>0 || (not captive)) then ((p+1),x,[p]) 
							      else if x=m then ((p+1),m,(p::l))
							      else ((p+1),m,l)) (0,(arity a),[]) multiset in
			     let le = List.length l in
			       if  le = 1 then List.hd l 
			       else if keep then c 
			       else (Array.of_list l).(ca_random le)
			  );
    doc_param a "captive" "Only consider states that are present in the nieghbourhood as a possible new state"


let _ =  valid maker 
