let name = "Boundary conditions"
let description = "It adds actions that modify boundaries of the configuration at each step."

open Acml

let maker a = (
  let c = cardinality a in
  let d = dimension a in
  add_measurement a ~set:false "Random boundaries" 
    (if d = 1 then 
       (fun t x y read write -> (
	  write 0 0 (conf_random c);
	  write (x-1) 0 (conf_random c)
	)
       )
     else
       (fun t x y read write ->
	  for i=0 to x-1 do
	    write i 0 (conf_random c);
	    write i (y-1) (conf_random c)
	  done;
	  for j=0 to y-1 do
	    write 0 j (conf_random c);
	    write (x-1) j (conf_random c)
	  done)
    );
  add_measurement a ~set:false "Null boundaries" 
    (if d = 1 then 
       (fun t x y read write -> (
	  write 0 0 0;
	  write (x-1) 0 0
	)
       )
     else
       (fun t x y read write ->
	  for i=0 to x-1 do
	    write i 0 0;
	    write i (y-1) 0
	  done;
	  for j=0 to y-1 do
	    write 0 j 0;
	    write (x-1) j 0
	  done)
    )

)

let _ = valid_plugin ~name ~activate:true
  ~executed_at:EachNewObject_after
  ~description
  maker

