let name = "Many colors" 
let description = "It adds various colormaps."

open Acml

let gradients = [
  "Cyclic Gray scale", [|(0,0,0); (255, 255, 255); (0,0,0)|];
  "Fire", [|(0,0,0); (255,0,0); (255,255,0); (255,255,255)|];
  "Martian juice", [|(0,0,0); (0,255,0); (255,255,0); (100,100,100)|];
  "Wine", [|(250,250,90);  (200, 120, 49); (97, 2, 27); (250,20,20)|];
  "Kind of blue", [|(0, 50, 250); (180, 180, 200); (0,0,100)|];
  "Variety", [|(0,0,0); (202,85,43); (43,107,202); (178,202,43); (177,185,191); (38,163,68); (134,97,160)|];
  "Candy", [|(255,255,0); (255,0,255); (0,255,255)|];
  "Washed", [|(150,150,150); (250,200,150); (200,150,150); (150,150,200)|];
  "Salad bowl", [|(0,0,255);(155,0,155);(155,155,0);(255,0,0);(0,155,155);(0,255,0)|];
  "Melting pot", [|(0,0,0);(255,0,0);(0,100,100);(55,55,55)|];
]

let maker a = (
    let donteraseuserchoice = Kernel.defaultcolormapname = get_view a in
    List.iter (fun (n,p) -> add_colormap a ~set:donteraseuserchoice n (color_gradient a p)) gradients;
    let rd_triple n = (Random.int n, Random.int n, Random.int n) in
    let grad = [|(0,0,0); rd_triple 128; rd_triple 256|] in
    add_colormap a "Random dark to bright" (color_gradient a grad);
    let grad = [|rd_triple 256; rd_triple 256; rd_triple 256; rd_triple 256|] in
    add_colormap a "Full random" (color_gradient a grad);
  )
            
let _ = valid_plugin ~activate:true ~executed_at:EachNewObject_after ~name ~description maker

