open Acml

let maker a = (
  let c_grp = param a "horizontal" 1 50 2 in
  let t_grp = param a "vertical" 1 50 2 in
  let c = cardinality a in
  let rec grp_card acc x = if x=0 then acc else grp_card (acc*c) (x-1) in
  let mx = grp_card 1 c_grp in
  let rec shift acc i = if (acc lsl 1) > 255 then i else shift (acc lsl 1) (i+1) in
    add_view a "Grouping" (fun x y read -> 
				       let nx = c_grp*(x/c_grp) and ny = t_grp*(y/t_grp) in
				       let rec grp_read acc i = if i= -1 then acc else grp_read ((acc * c) 
												 + (read (nx+i) ny)) (i-1)
				       in
				       let c = (grp_read 0 (c_grp-1)) lsl (shift mx 0) in
					 Unicolor (c,c,c)
				    );
    doc_param a "horizontal" "How many cells are grouped horizontally";
    doc_param a "vertical" "How many cells are grouped vertically"
)

let _ = valid_plugin 
  ~executed_at:EachNewObject_after
  ~name:"Grouping" 
  ~description:"It adds a grouping view in which cells are displayed by group: a single color is given to each group depending on its content.\nThe plugin adds parameters for controlling the size of groups." maker

