open Acml

let maker a = (
  let c = cardinality a in
  let pattern = text_param a "pattern"
    "00000
00100
00010
01110
00000" in
  let line_array = Array.of_list (Str.split (Str.regexp "[;\n]+") pattern) in
  let l = Array.length line_array in
    add_init_conf a "Periodic init conf" (General (fun i j ->
				try
				  let line = line_array.(j mod l) in
				    (int_of_string (String.sub line (i mod (String.length line)) 1)) mod c
				with _ -> 0
			     ));
    doc_param a "pattern" "for one-dimensional CA, only the first line is considered"
)

let _ = valid_plugin ~executed_at:EachNewObject_after
~name:"Periodic initial configurations" 
~description:"Sets a periodic initial configuration depending on the parameter 'pattern'."
maker

