open Acml;;

let maker a =
  (
    let _ = std_params ~states_fixed:true a in
    let neighbs = List.filter (fun x -> x<>(0,0)) (neighbors a) in
    let threshold = (List.length neighbs) in
    set_cardinality a (2*threshold);
    set_rule a (fun x -> let incoming = List.fold_left (fun acc (u,v) -> acc + (if x.(relativecell a u v) >= threshold then 1 else 0)) 0 neighbs
			      in
			   if x.(centercell a) >= threshold then x.(centercell a)+incoming-threshold else x.(centercell a)+incoming);
    add_colormap a "Sandpile" ~set:true (fun i -> let c = (255*i)/(2*threshold) in
        if i < threshold then  Unicolor (c,c,c) else Unicolor (c,0,0));
    set_name a "Sand pile";
    add_description a "General idea" 
      "Consider each cell as a pile of sand of a certain height. When a cell has sufficiently many grains, it gives one grain to each of its neighbors.";
  ) in
  valid maker
