let _ = 
  if (Array.length Sys.argv <= 1) then exit 0;

  let do_one i name =
    let safe_nick f =
      try
	Filename.chop_extension (Filename.basename f)
      with _ -> f in
    let petitnom = (safe_nick name)^"_BUILTIN.ml" in
    let readall esc flu =
      let flux = open_in name in
      let trans = if esc then String.escaped else fun x->x in
      let rec doit () = 
	try 
	  Printf.fprintf flu "%s\n" (trans (input_line flux));
	  doit ()
	with End_of_file -> (flush flu; close_in flux)
      in doit ()
    in 
    let mt f = (Unix.stat f).Unix.st_mtime in
      if (not (Sys.file_exists petitnom)) || ((mt petitnom) < (mt name)) then
	let fluo = open_out petitnom in
	  (
	    Printf.fprintf fluo "let _ = Kernel.preset_builtin {(Kernel.default_builtin ()) with Kernel.nickname=\"%s\"; Kernel.fullname=\"%s\"; Kernel.filename=\"%s\";\nKernel.src=\"" 
	      (safe_nick name) (safe_nick name) name;
 	    readall true fluo;
	    Printf.fprintf fluo "\"}\n(***************)\n\n";
	    readall false fluo;
	    Printf.fprintf fluo "\n\n(***************)\nlet _ = if Kernel.last_load_is_plugin () then Kernel.erase_builtin ();\nKernel.reset_last_load ()\n";
	    close_out fluo;
 	    Printf.fprintf stderr "(+) %s generated\n" petitnom
	  )
  in
    (
      for i = 1 to Array.length Sys.argv - 1 do
	do_one i Sys.argv.(i)
      done;
    )
	    
