open Digest

let _ = 
  assert (Array.length Sys.argv > 1);
  let readall esc f_in f_out =
    let trans = if esc then String.escaped else fun x->x in
    let rec doit () = 
      try 
	Printf.fprintf f_out "%s\n" (trans (input_line f_in));
	doit ()
      with End_of_file -> flush f_out
    in doit ()
  in 
    Printf.printf "let sig_fun = function\n";
    for i = 1 to Array.length Sys.argv - 1 do
      let f = Sys.argv.(i) in
      let md5 = to_hex (file f) in
      let mt = (Unix.stat f).Unix.st_mtime in
      let name = Filename.basename f in
	if (Filename.check_suffix name ".ml") then 
	  Printf.printf "| \"%s\" -> (\"%s\",%f)\n" (Filename.chop_suffix name ".ml") md5 mt
    done;
    Printf.printf "| _ -> (\"\",0.)\nlet _ = Kernel.register_sig sig_fun\n";
    List.iter (fun f ->
 		 let mli_name = (f^".mli") in
		 Printf.printf "let %s = \"" (f^"_mli ()");
		 if (Sys.file_exists mli_name) then (
		   let from = open_in mli_name in
		     readall true from stdout;
		     close_in from;
		 );
		 Printf.printf "\"\n"
	      )
      ["kernel"; "acml"; "random2"; "debug"; "keymap"]


