type debugcats = Dbgeneral | Dbgtk | Dbgdev | Dbginteract 
		 | Dbgsrce | Dbgsrco | Dbgsdl | Dbgwarning | Dbgdevsdl 
		 | Dbgtodo | Dbgsubprocess | Dbgfatal | Dbgitem | Dbguser

let internalbug s = failwith ("A non-trivial program must have a bug: "^s)

let predebugtag = [(Dbgeneral,""); (Dbgtk, "[gtk]"); (Dbgdev, "[debug]"); 
		(Dbginteract, "[info]"); (Dbgsrco, "[sub.out]"); (Dbgsrce, "[subERR]"); 
		(Dbgsdl, "[sdl]"); (Dbgwarning, "[WARNING]"); (Dbgtodo, "!!! TODO:");
		(Dbgdevsdl, "[sdldbg]"); (Dbgfatal, "[FATAL]");
		(Dbgitem, "+"); (Dbguser, "---->")
	       ]

let debugtag =
  let lmax = List.fold_left (fun acc x -> max acc (String.length (snd x))) 0 predebugtag in
  let adj s = (String.make (lmax-(String.length s)) ' ')^s^" " in
    List.map (fun x -> if (fst x = Dbgeneral) then x else (fst x, adj (snd x))) predebugtag

let (newlineflusherr, remembertonewline) =
  let todo = ref false in
    ((fun () -> if !todo then (prerr_newline (); todo:=false)),
     (fun () -> todo := true)
    )

let (getdebugcats, setdebugcats, removedebugcat, adddebugcat, ondebug, unlessdebug, debug, debugline, debugdoing, debugdone) =
  let optional = [Dbgdev; Dbgdevsdl; Dbgsdl; Dbgtk] in
  let cats = ref (List.fold_left (fun acc x -> if (List.mem (fst x) optional) then acc else (fst x)::acc) [] debugtag) in
  let indoing = ref false in
    (
      (fun () -> !cats),
      (fun l -> cats :=l),
      (fun x -> cats := (List.filter (fun y -> x<>y) !cats)),
      (fun x -> cats := x::(!cats)),
      (fun c f -> if List.mem c !cats then f ()),
      (fun c f -> if not (List.mem c !cats) then f ()),
      (fun c s -> if List.mem c !cats then (
	 prerr_string s; flush stderr
       )
      ),
      (fun c s -> if List.mem c !cats then 
	 try
	   newlineflusherr (); prerr_string (List.assoc c debugtag); 
	   prerr_string s; if not !indoing then prerr_newline () else prerr_string " "; flush stderr
	 with Not_found -> internalbug "debugline"
      ),
      (fun c s -> if List.mem c !cats then 
	 try
	   newlineflusherr (); prerr_string (List.assoc c debugtag); 
	   prerr_string (s^"..."); indoing := true; flush stderr
	 with Not_found -> internalbug "debugdoing"
      ),
      (fun c ->
	if List.mem c !cats then (prerr_string "done."; indoing := false; prerr_newline (); flush stderr)
      )
    )

let textprogressmeter  () =
  let pos = ref 0 in (fun i ->
			if !pos = 0 then 
			  try 
			    (debug Dbginteract ((List.assoc Dbginteract debugtag)^"Processing..."); 
			     pos := 1) 
			  with Not_found -> internalbug "textprogressmeter"
			else if i mod 10 = 0 then debug Dbginteract ".";
			remembertonewline ())

